//import hooks;
import generic_hooks;
import statuses;
import target_filters;
//from empire_effects import ModEmpireAttribute;
from generic_effects import UpdatedValue;
from bonus_effects import BonusEffect;
from statuses import getStatusID;
//from ability_effects import getMassFor;
//from empire import Creeps;
//from empire import Pirates;
import string getRandomFlagshipName() from "card_effects";
import string getRandomPlanetName() from "card_effects";
//from statuses import StatusHook;

//#section server-side
//from regions.regions import getRegion;
//#section all

//from orders.LeaderAI import addExperience;
//#section server
//from components.FleetManager import FleetManager;
//#section all

class AddWraithPopulationStatus : BonusEffect {
	Document doc("Add a status effect to the target object.");
	Argument type(AT_Status, doc="Type of status effect to add.");
	Argument duration(AT_Decimal, "-1", doc="Duration to add the status for, -1 for permanent.");
	Argument set_origin_empire(AT_Boolean, "False", doc="Whether to record the empire triggering this hook into the origin empire field of the resulting status. If not set, any hooks that refer to Origin Empire cannot not apply. Status effects with different origin empires set do not collapse into stacks.");
	Argument set_origin_object(AT_Boolean, "False", doc="Whether to record the object triggering this hook into the origin object field of the resulting status. If not set, any hooks that refer to Origin Object cannot not apply. Status effects with different origin objects set do not collapse into stacks.");
	//Argument max_stacks(AT_Integer, "0", doc="If set to more than 0, never add stacks beyond a certain amount.");
	Argument attribute(AT_EmpAttribute, doc="Hiveship count.");

#section server
	void activate(Object@ obj, Empire@ emp) const override {
		if(obj is null)
			return;
		Empire@ origEmp = null;
		if(set_origin_empire.boolean)
			@origEmp = emp;
		Object@ origObj = null;
		if(set_origin_object.boolean)
			@origObj = obj;

		double HiveshipCount = emp.getAttribute(attribute.integer);
		double TotalPopulation = obj.owner.TotalPopulation;
		//Max 16 pop per Hiveship => gives 10 population on Hiveship
		//double TargetHiveshipPopulation = min(TotalPopulation/HiveshipCount, 16.0)/16 * 10;
		double TargetHiveshipPopulation = min(TotalPopulation/HiveshipCount, 24.0)/24.0;
		Ship@ ship = cast<Ship>(obj);
		//int shipSize = ship.blueprint.design.size;
		double shipSize = double(ship.blueprint.design.size);
		//print(shipSize);
		//Adjust for size up or down from 10 @ Size 1250
		//TargetHiveshipPopulation *= double(shipSize)/1250.0;
		//print(pow(max(double(shipSize)-1250.0,1.0),(1.0/2.5)));
		//Scales down as ship size increases
		//TargetHiveshipPopulation *= min(shipSize/125.0, 10.0)+pow(max(shipSize-1250.0,1.0),(1.0/2.5))-1;	//MIN(Size/1250.0,10.0)+(MAX((Size-1250),1))^(1/2.5)-1
		//Slightly less rolloff than above and scales out a bit higher
		//TargetHiveshipPopulation *= 10+pow(max((shipSize-1250)/2.0,1.0),(1.0/2.25))-1;	//10+(MAX((Size-1250)/2,1))^(1/2.25)-1
		//Always gives consistent return for size, increasing as size increases to extremes
		//TargetHiveshipPopulation *= 10.0+6.5*pow((1.8+0.16*log(shipSize/1375.0)),log(shipSize/1375.0));		//10+6.5*((1.8+0.16*LOG(Size/1375,2.718281))^LOG(Size/1375,2.718281))
		//Fixing the above to actually use log base 2 scaling instead of natural log
		TargetHiveshipPopulation *= 8.0+6.5*pow((1.8+0.00675*log(shipSize/1375.0)/log(2.0)),log(shipSize/1375.0)/log(2.0));		//10+6.5*((1.8+0.01*LOG(Size/1375,2))^LOG(Size/1375,2))
		//print(TargetHiveshipPopulation);
		//error("Hiveships = "+HiveshipCount.str+", TotalPlanetPopulstion = "+TotalPopulation.str+", TargetHivePopulation = "+TargetHiveshipPopulation.str);
		//print(HiveshipCount);
		//print(TotalPopulation);
		//print(TargetHiveshipPopulation);

//		if(max_stacks.integer > 0) {
//			if(obj.getStatusStackCount(type.integer, originEmpire=origEmp, originObject=origObj) >= uint(max_stacks.integer))
//				return;
//		}
//		obj.addStatus(uint(type.integer), duration.decimal, originEmpire=origEmp, originObject=origObj);

		if(obj.getStatusStackCount(type.integer, originEmpire=origEmp, originObject=origObj) > uint(TargetHiveshipPopulation))  {
			obj.removeStatusInstanceOfType(uint(type.integer));
			return;
		}
		else if(obj.getStatusStackCount(type.integer, originEmpire=origEmp, originObject=origObj) == uint(TargetHiveshipPopulation))  {
			//Do nothing
			return;
		}
		obj.addStatus(uint(type.integer), duration.decimal, originEmpire=origEmp, originObject=origObj);
	}
#section all
};

/*
class AddHiveshipScaledMoneyIncome : EmpireEffect, TriggerableGeneric {
	Document doc("Determine income stack for population based on Hiveship size.)");
	Argument amount(AT_Integer, doc="Amount of income per cycle to add.");
	Argument scaling(AT_Integer, doc="Default size for Amount to scale from.");

#section server
	void enable(Object@ obj, Empire& owner, any@ data) {
		int ScaledAmount = 0;
		print(ScaledAmount);
		ScaledAmount = GetScaledAmount(obj);
		print(ScaledAmount);
		owner.modTotalBudget(ScaledAmount, MoT_Misc);
	}

	void disable(Object@ obj, Empire& owner, any@ data) {
		int ScaledAmount = 0;
		ScaledAmount = GetScaledAmount(obj);
		owner.modTotalBudget(-ScaledAmount, MoT_Misc);
	}

#section all
	int GetScaledAmount(Object@ obj)  {
		Ship@ ship = cast<Ship>(obj);
		int ShipSize = ship.blueprint.design.size;
		return uint(amount.integer) * (uint(scaling.integer)/ShipSize);
	}
};
*/


/*
class GetHiveshipCount : EmpireEffect {
	Document doc("Add a status effect to the target object.");
	Argument attribute(AT_EmpAttribute, doc="Hiveship count.");

#section server
	void activate(Empire@ emp) {
		uint HiveshipCount = emp.getAttribute(attribute.integer);
		return HiveshipCount;
	}
#section all
};
*/

class ModEfficiencyDistanceToResurrectionSource : GenericEffect {
	Document doc("Modify the efficiency of the fleet based on the distance to the nearest owned orbital of a particular type.");
	Argument minrange_efficiency(AT_Decimal, doc="Efficiency at minimum range.");
	Argument maxrange_efficiency(AT_Decimal, doc="Efficiency at maximum range.");
	Argument minrange(AT_Decimal, doc="Minimum range for min efficiency.");
	Argument maxrange(AT_Decimal, doc="Maximum range for max efficiency.");

#section server
	void enable(Object& obj, any@ data) const override {
		UpdatedValue value;
		data.store(@value);
	}
	/*
	Ship@ getClosestResurrectionSource(const vec3d& position) {
		ReadWriteMutex fleetMutex;
		Object@[] fleetList;
		ReadLock lock(fleetMutex);
		Ship@ closest;		
		double closestDist = INFINITY;
		for(uint i = 0, cnt = fleetList.length; i < cnt; ++i) {
			Ship@ source = cast<Ship>(fleetList[i]);
			auto@ bp = source.blueprint;
			if(bp.design.hasSubsystem(subsystem::CylonResurrectionFlagship) || bp.design.hasSubsystem(subsystem::CylonResurrectionStation))  {
				double d = source.position.distanceToSQ(position);
				if(d < closestDist) {
					closestDist = d;
					@closest = source;
				}
			}
		}
		return closest;
	}
	*/

	void tick(Object& obj, any@ data, double time) const override {
		UpdatedValue@ value;
		data.retrieve(@value);

		value.timer -= time;
		if(value.timer <= 0) {
			value.timer = randomd(0.5, 5.0);

			double prevValue = value.value;
			double dist = maxrange.decimal+1;
			//Ship@ closest = obj.owner.getClosestResurrectionSource(obj.position);
			
			//ReadWriteMutex fleetMutex;
			//Object@[] fleetList;
			//ReadLock lock(fleetMutex);
			Empire@ emp = obj.owner;			
			Object@ closest;		
			double closestDist = INFINITY;
			uint fleetCount = emp.get_shipFleetCount();			
			//print("FleetList length = "+fleetCount);
			for(uint i = 0, cnt = fleetCount; i < cnt; ++i) {
				//print("Checking fleet "+i);
				//Object@ source = fleets[i];
				Object@ source = emp.get_shipFleet(i);
				//if(source is null)  print("Fleet "+i+" is null");
				//if(!source.isShip)  print("Fleet "+i+" is not a ship");
				//Failsafe against occassional errors
				if(source is null)  continue;
				if(source.isShip)  {					
					Ship@ ship = cast<Ship>(source);
					//if(ship is null)  print("Blueprint for fleet "+i+" is null");
					//Skip ourself
					//if(obj is source)  print("Fleet "+i+" is self");
					if(obj is source)  continue;
					auto@ bp = ship.blueprint;
					if(bp.design.hasSubsystem(subsystem::CylonResurrectionFlagship) || bp.design.hasSubsystem(subsystem::CylonResurrectionStation))  {
						//print("Resurrection Source found");
						double d = source.position.distanceToSQ(obj.position);
						//print("Range to Resurrection Source = "+d);
						if(d < closestDist) {							
							closestDist = d;
							@closest = source;
						}
					}
				}
			}
			
			if(closest !is null)
				dist = closest.position.distanceTo(obj.position);
			
			/*
			if(dist <= minrange.decimal) {
				value.value = minrange_efficiency.decimal;
			}
			else if(dist >= maxrange.decimal) {
				value.value = maxrange_efficiency.decimal;
			}
			else {
				double pct = (dist - minrange.decimal) / (maxrange.decimal - minrange.decimal);
				value.value = minrange_efficiency.decimal + pct * (maxrange_efficiency.decimal - minrange_efficiency.decimal);
			}
			*/
			//print("Closest distance to Resurrection Source = "+closestDist);
			//print("Distance to Resurrection Source = "+dist);
			if(dist <= maxrange.decimal)  value.value = minrange_efficiency.decimal;
			else  value.value = maxrange_efficiency.decimal;
			
			if(prevValue != value.value)
				obj.modFleetEffectiveness(value.value - prevValue);
		}
	}

	void disable(Object& obj, any@ data) const override {
		UpdatedValue@ value;
		data.retrieve(@value);

		//if(value.value > 0) {
		if(value.value != 0) {
			obj.modFleetEffectiveness(-value.value);
			value.value = 0;
		}
		
		//If we are null or not a ship, exit
		if(obj is null || !obj.isShip) return; 
		//Redistribute 100% of dying ship's XP
		Ship@ leader = cast<Ship>(obj);
		const Design@ design;
		double needExp = 0;
		double totalExp = 0;
		int curLevel = 0;
		if(leader !is null)
			@design = leader.blueprint.design;
		if(design !is null) {
			int levelStatus = -1;
			levelStatus = getStatusID("ShipLevel");
			curLevel = leader.getStatusStackCountAny(levelStatus);
			needExp = leader.getRemainingExp();
			totalExp = design.size * (config::EXPERIENCE_BASE_AMOUNT + config::EXPERIENCE_INCREASE_AMOUNT * curLevel);
		}
		double XPToDistribute = 0;
		if (curLevel > 0)  {
			for(int i = 0; i < curLevel; ++i)
				XPToDistribute += design.size * (config::EXPERIENCE_BASE_AMOUNT + config::EXPERIENCE_INCREASE_AMOUNT * double(i));
		}
		XPToDistribute += totalExp - needExp;
		//print("XP to Distribute = "+XPToDistribute);
		//If we have 0 experience, exit since there is nothing to do
		if (XPToDistribute == 0)  return;
		
		array<Object@> ValidFleets;
		array<Object@> ResurrectionSources;
		
		//Inventory valid fleets and Resurrection sources
		Empire@ emp = obj.owner;
		uint fleetCount = emp.get_shipFleetCount();	
		for(uint i = 0, cnt = fleetCount; i < cnt; ++i) {
			Object@ source = emp.get_shipFleet(i);
			//Failsafe against occassional errors
			if(source is null)  continue;
			if(source.isShip)  {
				Ship@ ship = cast<Ship>(source);
				//if(ship is null)  print("Blueprint for fleet "+i+" is null");
				auto@ bp = ship.blueprint;
				//Do not include dying ship
				if(obj is source)  continue;
				//Skip scouts and miners
				else if(bp.design.cls.name == "Exploration")  continue;
				//Resurrection Sources
				else if(bp.design.hasSubsystem(subsystem::CylonResurrectionFlagship) || bp.design.hasSubsystem(subsystem::CylonResurrectionStation))  {
					ResurrectionSources.insertLast(source);
					ValidFleets.insertLast(source);
				}
				//The rest
				else  {
					ValidFleets.insertLast(source);
				}
			}
		}
		
		//print("ValidFleets = "+ValidFleets.length);
		//print("ResurrectionSources = "+ResurrectionSources.length);
		
		//Check to see if we are within range of a source
		bool bInRange = false;
		for(uint i = 0, cnt = ResurrectionSources.length; i < cnt; ++i)  {
			if (obj.position.distanceTo(ResurrectionSources[i].position) <= 500000)  {
				//We are in range and we can exit the check
				bInRange = true;
				break;
			}
		}
		//If we're not in range exit
		if(!bInRange)  return;
		//print("Died in range of Resurrection source");
		
		array<Object@> FleetsInRange;
		for(uint i = 0, cnt = ValidFleets.length; i < cnt; ++i)  {
			Object@ current = ValidFleets[i];
			bInRange = false;
			for(uint r = 0, cnt = ResurrectionSources.length; r < cnt; ++r)  {
				if (current.position.distanceTo(ResurrectionSources[r].position) <= 500000)  {
					//We are in range and we can exit the check
					FleetsInRange.insertLast(current);
					break;
				}
			}
		}
		//print("Fleets in range to receive XP = "+FleetsInRange.length);
				
		double XPPerFleet = floor(XPToDistribute / FleetsInRange.length);
		//print("XP to distribute per candidate fleets = "+XPPerFleet);
		if(XPPerFleet == 0)  return;
		for(uint i = 0, cnt = FleetsInRange.length; i < cnt; ++i)  {
			Object@ current = FleetsInRange[i];
			//print("Granting XP to fleet in range #"+i);
			Ship@ ship = cast<Ship>(current);
			current.addExperience(XPPerFleet);
		}
	}

	void save(any@ data, SaveFile& file) const override {
		UpdatedValue@ value;
		data.retrieve(@value);
		file << value.value;
		file << value.timer;
	}

	void load(any@ data, SaveFile& file) const override {
		UpdatedValue value;
		file >> value.value;
		file >> value.timer;
		data.store(value);
	}
#section all
};

class ModEfficiencyDistanceToBorgQueen : GenericEffect {
	Document doc("Modify the efficiency of the fleet based on the distance to the nearest owned orbital of a particular type.");
	Argument minrange_efficiency(AT_Decimal, doc="Efficiency at minimum range.");
	Argument maxrange_efficiency(AT_Decimal, doc="Efficiency at maximum range.");
	Argument minrange(AT_Decimal, doc="Minimum range for min efficiency.");
	Argument maxrange(AT_Decimal, doc="Maximum range for max efficiency.");

#section server
	void enable(Object& obj, any@ data) const override {
		UpdatedValue value;
		data.store(@value);
	}
	/*
	Ship@ getClosestResurrectionSource(const vec3d& position) {
		ReadWriteMutex fleetMutex;
		Object@[] fleetList;
		ReadLock lock(fleetMutex);
		Ship@ closest;		
		double closestDist = INFINITY;
		for(uint i = 0, cnt = fleetList.length; i < cnt; ++i) {
			Ship@ source = cast<Ship>(fleetList[i]);
			auto@ bp = source.blueprint;
			if(bp.design.hasSubsystem(subsystem::CylonResurrectionFlagship) || bp.design.hasSubsystem(subsystem::CylonResurrectionStation))  {
				double d = source.position.distanceToSQ(position);
				if(d < closestDist) {
					closestDist = d;
					@closest = source;
				}
			}
		}
		return closest;
	}
	*/

	void tick(Object& obj, any@ data, double time) const override {
		UpdatedValue@ value;
		data.retrieve(@value);

		value.timer -= time;
		if(value.timer <= 0) {
			value.timer = randomd(0.5, 5.0);

			double prevValue = value.value;
			double dist = maxrange.decimal+1;

			Empire@ emp = obj.owner;
			Ship@ linkedship = cast<Ship>(obj);
			Object@ closest;	
			double closestDist = INFINITY;
			uint fleetCount = emp.get_fleetCount();			
			//print("FleetList length = "+fleetCount);
			for(uint i = 0, cnt = fleetCount; i < cnt; ++i) {
				//print("Checking fleet "+i);
				//Object@ source = fleets[i];
				Object@ source = emp.get_fleets(i);
				//if(source is null)  print("Fleet "+i+" is null");
				//if(!source.isShip)  print("Fleet "+i+" is not a ship");
				//Failsafe against occassional errors
				if(source is null)  continue;
				if(source.isShip)  {					
					Ship@ ship = cast<Ship>(source);
					//if(ship is null)  print("Blueprint for fleet "+i+" is null");
					//Skip ourself
					//if(obj is source)  print("Fleet "+i+" is self");
					//if(obj is source)  continue;
					auto@ bp = ship.blueprint;
					if(bp.design.hasTag(ST_BorgQueen))  {
						//print("Resurrection Source found");
						double d = source.position.distanceToSQ(obj.position);
						//print("Range to Resurrection Source = "+d);
						if(d < closestDist) {							
							closestDist = d;
							@closest = source;
						}
					}
				}
			}
			
			if(closest !is null)
				dist = closest.position.distanceTo(obj.position);
			
			//print("Linked Ship's adaptationFactor = "+linkedship.AdaptationFactor);
			if(dist <= minrange.decimal) {
				value.value = minrange_efficiency.decimal;
				if(linkedship !is null)  linkedship.AdaptationFactor = 2.0;
				//if(linkedship !is null)  linkedship.setAdaptationFactor(2.0);
			}
			else if(dist >= maxrange.decimal) {
				value.value = maxrange_efficiency.decimal;
				if(linkedship !is null)  linkedship.AdaptationFactor = 1.0;
				//if(linkedship !is null)  linkedship.setAdaptationFactor(1.0);
			}
			else {
				double pct = (dist - minrange.decimal) / (maxrange.decimal - minrange.decimal);
				value.value = minrange_efficiency.decimal + pct * (maxrange_efficiency.decimal - minrange_efficiency.decimal);
				if(linkedship !is null)  linkedship.AdaptationFactor = 2.0;
				//if(linkedship !is null)  linkedship.setAdaptationFactor(2.0);
			}			
			//print("Closest distance to Resurrection Source = "+closestDist);
			//print("Distance to Resurrection Source = "+dist);
			//if(dist <= maxrange.decimal)  value.value = minrange_efficiency.decimal;
			//else  value.value = maxrange_efficiency.decimal;
			
			if(prevValue != value.value)
				obj.modFleetEffectiveness(value.value - prevValue);
		}
	}

	void disable(Object& obj, any@ data) const override {
		UpdatedValue@ value;
		data.retrieve(@value);

		//if(value.value > 0) {
		if(value.value != 0) {
			obj.modFleetEffectiveness(-value.value);
			value.value = 0;
		}
		if(obj.isShip)  cast<Ship>(obj).AdaptationFactor = 1.0;
		//if(obj.isShip)  cast<Ship>(obj).setAdaptationFactor(1.0);
	}

	void save(any@ data, SaveFile& file) const override {
		UpdatedValue@ value;
		data.retrieve(@value);
		file << value.value;
		file << value.timer;
	}

	void load(any@ data, SaveFile& file) const override {
		UpdatedValue value;
		file >> value.value;
		file >> value.timer;
		data.store(value);
	}
#section all
};

// Almost certainly don't need ALL these imports.  Strip them out later if it bothers you.
// don't make this zero, but change it to determine how much population a mothership should have per size.
	//const double CYLON_STATION_SIZE_DIVISOR = 65; 

class CylonStationPopulationGrowth : BonusEffect {
	Document doc("Add the population status effect to the target object, which should be a Colony Station.");
	
#section server
	void activate(Object@ obj, Empire@ emp) const override {
		if(obj is null)  {
			//print("Obj is null");
			return;
		}
		Empire@ origEmp = null;
		Object@ origObj = null;

		int statusId = getStatusType("CylonStationPopulation").id; 
		int max_stacks = FigureOutStationSizeToStacks(obj);
		if(obj.getStatusStackCount(statusId, originEmpire=origEmp, originObject=origObj) >= uint(max_stacks))
			return;
			
		// implicit else - used a lot in SR2 coding.  -1 duration means infinite.
		obj.addStatus(uint(statusId), -1, originEmpire=origEmp, originObject=origObj);
	}
#section all

	int FigureOutStationSizeToStacks(Object@ obj)
	{
		// So we know obj has to be a ship, and isn't null - so we can cast it to ship.
		Ship@ ship = cast<Ship>(obj);
		
		int shipSize = ship.blueprint.design.size;
		//print("Station size = "+shipSize);
		
		//5 pop @ size 2000, plus 1 per additional 1000 size
		return floor((shipSize-2000)/1000+5);
	}
};

class CylonStationColonizePlanet : BonusEffect {
	Document doc("The planet this is triggered on instantly gains an amount of population.");
	Argument amount(AT_Decimal, doc="Amount of population to gain.");
	Argument allow_over(AT_Boolean, "True", doc="Whether to allow temporarily going over population capacity.");

#section server
	void activate(Object@ obj, Empire@ emp) const override {
		//Take Control
		if(obj is null || emp is null)
			return;
		if(obj.isPlanet)
			obj.takeoverPlanet(emp, 0.5);
		else if(obj.isShip && obj.hasLeaderAI)
			obj.takeoverFleet(emp, 1.0, false);
		else
			@obj.owner = emp;
		//Give Population
		if(obj is null || !obj.hasSurfaceComponent)
			return;
		obj.addPopulation(amount.decimal, allow_over.boolean);
	}
#section all
};

class AddOnboardResearchIncome : GenericEffect {
	Document doc("Increase research income per second based on subsystem variable.");
	Argument amount(AT_SysVar, doc="Amount of research generation per second to add, before generation penalties.");
	//Argument amount(AT_Decimal, doc="Amount of research generation per second to add, before generation penalties.");

#section server
	void enable(Object& obj, any@ data) const override {
		Empire @owner = obj.owner;
		double amt = amount.fromShipEfficiencySum(obj);
		//print("Onboard Research to add = "+amt);
		owner.modResearchRate(+amt);
	}

	void disable(Object& obj, any@ data) const override {
		Empire @owner = obj.owner;
		double amt = amount.fromShipEfficiencySum(obj);
		owner.modResearchRate(-amt);
	}
#section all
};

class AddOnboardInfluenceIncome : GenericEffect {
	Document doc("Increase influence income per second based on subsystem variable.");
	Argument amount(AT_SysVar, doc="Amount of research generation per second to add, before generation penalties.");
	//Argument amount(AT_Decimal, doc="Amount of research generation per second to add, before generation penalties.");

#section server
	void enable(Object& obj, any@ data) const override {
		Empire @owner = obj.owner;
		double amt = amount.fromShipEfficiencySum(obj);
		//print("Onboard Influence to add = "+amt);
		owner.modInfluenceIncome(+amt);
	}

	void disable(Object& obj, any@ data) const override {
		Empire @owner = obj.owner;
		double amt = amount.fromShipEfficiencySum(obj);
		owner.modInfluenceIncome(-amt);
	}
#section all
};

class AddOnboardMoneyIncome : GenericEffect {
	Document doc("Increase money income per second based on subsystem variable.");
	Argument amount(AT_SysVar, doc="Amount of research generation per second to add, before generation penalties.");
	//Argument amount(AT_Decimal, doc="Amount of research generation per second to add, before generation penalties.");

#section server
	void enable(Object& obj, any@ data) const override {
		Empire @owner = obj.owner;
		double amt = amount.fromShipEfficiencySum(obj);
		//print("Onboard Money to add = "+amt);
		owner.modTotalBudget(+amt);
	}

	void disable(Object& obj, any@ data) const override {
		Empire @owner = obj.owner;
		double amt = amount.fromShipEfficiencySum(obj);
		owner.modTotalBudget(-amt);
	}
#section all
};

/*
class LimitStationFlagPerSystem : GenericEffect {
	Document doc("This station can only be constructed once per system.");
	Argument flag(AT_SystemFlag, doc="System flag to base the once per system limit on. Can be set to any arbitrary unique name.");
	Argument any_empire(AT_Boolean, "False", doc="If set to true, only one empire may build this in a system.");

	bool canBuildAt(Object@ obj, const vec3d& pos) const {
		auto@ system = getRegion(pos);
		if(system is null)
			return false;
		if(obj is null)
			return false;
		return !check(obj, system);
	}
	
	bool check(Object& obj, Region@ system) {
		if(any_empire.boolean)
			return system.getSystemFlagAny(flag.integer);
		else
			return system.getSystemFlag(obj.owner, flag.integer);
	}

	string getBuildError(Object@ obj, const vec3d& pos) const {
		return locale::OERR_LIMIT;
	}
	
#section server
	void onOwnerChange(Ship& obj, any@ data, Empire@ prevOwner, Empire@ newOwner) const override {
		Region@ region = obj.region;
		if(region !is null) {
			if(prevOwner !is null && prevOwner.valid)
				region.setSystemFlag(prevOwner, flag.integer, false);
			if(newOwner !is null && newOwner.valid) {
				if(region.getSystemFlag(newOwner, flag.integer))
					obj.destroy();
				else
					region.setSystemFlag(newOwner, flag.integer, true);
			}
		}
	}

	void onRegionChange(Ship& obj, any@ data, Region@ fromRegion, Region@ toRegion) const override {
		Empire@ owner = obj.owner;
		if(owner !is null && owner.valid) {
			if(fromRegion !is null)
				fromRegion.setSystemFlag(owner, flag.integer, false);
			if(toRegion !is null) {
				if(check(obj, toRegion)) {
					if(!obj.inFTL)
						obj.destroy();
				}
				else
					toRegion.setSystemFlag(owner, flag.integer, true);
			}
		}
	}

	void onEnable(Ship& obj, any@ data) const override {
		Region@ region = obj.region;
		Empire@ owner = obj.owner;
		if(region !is null && owner !is null && owner.valid) {
			if(check(obj, region))
				obj.destroy();
			else
				region.setSystemFlag(owner, flag.integer, true);
		}
	}

	void onDisable(Ship& obj, any@ data) const override {
		Region@ region = obj.region;
		Empire@ owner = obj.owner;
		if(region !is null && owner !is null && owner.valid)
			region.setSystemFlag(owner, flag.integer, false);
	}

	bool shouldDisable(Ship& obj, any@ data) const override {
		return obj.inFTL || obj.region is null;
	}

	bool shouldEnable(Ship& obj, any@ data) const override {
		return !obj.inFTL && obj.region !is null;
	}
#section all
};
*/

tidy final class SupportList {
	set_int set;
	array<Ship@> list;
};

class AddStrikecraftHangarBuff : GenericEffect {
	Document doc("Add a percentage bonus health to all strikecraft assigned to this.");
	//Argument amount(AT_Decimal, doc="Percentage of hp to add.");
	Argument amount(AT_SysVar, doc="Percentage of hp to add.");

#section server
	void enable(Object& obj, any@ data) const override {
		SupportList list;
		data.store(@list);
	}

	void tick(Object& obj, any@ data, double time) const override {
		SupportList@ list;
		data.retrieve(@list);
		if(list is null || !obj.hasLeaderAI)
			return;
			
		//double amt = amount.fromShipEfficiencySum(obj);
		double HPBuff = amount.fromShipEfficiencySum(obj);
		double DamageBuff = amount.fromShipEfficiencySum(obj) * 0.5;
		//print("Hangar Buff = "+HPBuff);

		uint supCnt = obj.supportCount;
		if(supCnt != 0) {
			uint offset = randomi(0, supCnt-1);
			for(uint checks = 0; checks < 10; ++checks) {
			//for(uint checks = 0; checks < supCnt; ++checks) {
				Ship@ support = cast<Ship>(obj.supportShip[(offset+checks)%supCnt]);
				//Ship@ support = cast<Ship>(obj.supportShip[checks]);
				if(support is null || list.set.contains(support.id))  continue;
				const Design@ dsg = support.blueprint.design;
				//if(support is null || list.set.contains(support.id))
				if(!dsg.hasTag(ST_Strikecraft))
					continue;
				//support.modHPFactor(+amt.decimal);
				support.modHPFactor(+HPBuff);
				support.addBonusEffectiveness(+DamageBuff);
				list.list.insertLast(support);
				list.set.insert(support.id);
			}
		}

		uint prevCnt = list.list.length;
		if(prevCnt != 0) {
			uint offset = randomi(0, prevCnt-1);
			for(uint checks = 0; checks < 5 && prevCnt != 0; ++checks) {
			//for(uint checks = 0; checks < prevCnt; ++checks) {
				Ship@ support = list.list[(offset+checks)%prevCnt];
				//Ship@ support = list.list[(checks)];
				const Design@ dsg = support.blueprint.design;
				//if(support.LeaderID != obj.id) {
				if(support.LeaderID != obj.id && dsg.hasTag(ST_Strikecraft)) {
					//support.modHPFactor(-amt.decimal);
					support.modHPFactor(-HPBuff);
					support.addBonusEffectiveness(-DamageBuff);

					list.list.removeAt((offset+checks)%prevCnt);
					//list.list.removeAt(checks);
					list.set.erase(support.id);
					--prevCnt;
				}
			}
		}
	}

	void disable(Object& obj, any@ data) const override {
		SupportList@ list;
		data.retrieve(@list);
		if(list is null)
			return;

		double HPBuff = amount.fromShipEfficiencySum(obj);
		double DamageBuff = amount.fromShipEfficiencySum(obj) * 0.5;	
			
		for(int i = list.list.length - 1; i >= 0; --i) {
			Ship@ ship = list.list[i];
			//ship.modHPFactor(-amt.decimal);
			ship.modHPFactor(-HPBuff);
			ship.addBonusEffectiveness(-DamageBuff);
		}

		list.list.length = 0;
		@list = null;
		data.store(@list);
	}

	void save(any@ data, SaveFile& file) const override {
		SupportList@ list;
		data.retrieve(@list);
		if(list is null) {
			file.write0();
			return;
		}
		file.write1();
		file << list.list.length;
		for(uint i = 0, cnt = list.list.length; i < cnt; ++i)
			file << list.list[i];
	}

	void load(any@ data, SaveFile& file) const override {
		if(file.readBit()) {
			SupportList list;
			data.store(@list);
			uint cnt = 0;
			file >> cnt;
			list.list.length = cnt;
			for(uint i = 0; i < cnt; ++i) {
				file >> list.list[i];
				list.set.insert(list.list[i].id);
			}
		}
	}
#section all
};

class HangarAllowConstruction : GenericEffect {
	Document doc("Permits the orbital or ship to construct various things.");
	Argument ships("Ships", AT_Boolean, "False", doc="Allow support and flagship construction.");
	Argument orbs("Orbitals", AT_Boolean, "False", doc="Allow orbital and station construction.");
	Argument asteroids(AT_Boolean, "False", doc="Allow asteroid mining base construction.");
	Argument terraform("Terraforming", AT_Boolean, "False", doc="Allow planet terraforming.");
	Argument supports_only("Supports Only", AT_Boolean, "False", doc="Only allow automatic construction of support ships.");
	Argument enable_fill_from(AT_Boolean, "False", doc="Automatically enable fill from the first time this is added.");

#section server
	void enable(Object& obj, any@ data) const override {
		/*
		//Debug
		if(!obj.hasConstruction)  print("Object does not already have construction");
		else  print("Object already has construction");
		if(arguments[0].boolean)  print("Set object can build ships");
		if(arguments[1].boolean)  print("Set object can build orbitals");
		if(arguments[2].boolean)  print("Set object can build asteroids");
		if(arguments[3].boolean)  print("Set object can terraform");
		if(arguments[4].boolean)  print("Set object can build supports only");
		*/
		if(!obj.hasConstruction) {
			if(obj.isOrbital) {
				cast<Orbital>(obj).activateConstruction();
				if(obj.hasLeaderAI && enable_fill_from.boolean)
					obj.allowFillFrom = true;
			}
			else if(obj.isShip)
				cast<Ship>(obj).activateConstruction();
			else
				return;
		}
		if(!obj.hasConstruction)  {
			obj.canBuildShips = arguments[0].boolean;
			obj.canBuildOrbitals = arguments[1].boolean;
			obj.canBuildAsteroids = arguments[2].boolean;
			obj.canTerraform = arguments[3].boolean;
			obj.canBuildSupports = ships.boolean || supports_only.boolean;
			//obj.canBuildSupports = arguments[0].boolean || arguments[4].boolean;
		}
		else{
			if(!obj.canBuildShips && arguments[0].boolean)  {
				obj.canBuildShips = arguments[0].boolean;
				obj.canBuildSupports = ships.boolean || supports_only.boolean;
				//obj.canBuildSupports = arguments[0].boolean || arguments[4].boolean;
			}
			else if(!obj.canBuildSupports && arguments[4].boolean)  obj.canBuildSupports = arguments[4].boolean;
			if(!obj.canBuildOrbitals && arguments[1].boolean)  obj.canBuildOrbitals = arguments[1].boolean;
			if(!obj.canBuildAsteroids && arguments[2].boolean)  obj.canBuildAsteroids = arguments[2].boolean;
			if(!obj.canTerraform && arguments[3].boolean)  obj.canTerraform = arguments[3].boolean;
		}
		
		Region@ reg = obj.region;
		if(reg !is null && (ships.boolean || supports_only.boolean))
		//if(reg !is null && (arguments[0].boolean || arguments[4].boolean))
			reg.registerShipyard(obj);
	}

	void disable(Object& obj, any@ data) const override {
		if(!obj.hasConstruction)
			return;
		obj.canBuildShips = false;
		obj.canBuildOrbitals = false;
		obj.canBuildAsteroids = false;
		obj.canTerraform = false;
	}
#section all
};

//Limit restriction from applying to objects that have construction from sources other than Hangar Bays.
class HangarForbidLaborExport : GenericEffect, TriggerableGeneric {
	Document doc("Forbid the object this effect is active in from exporting labor to other objects.");

#section server
	void enable(Object& obj, any@ data) const override {
		/*
		//Debug
		if(obj.canBuildShips)  print("Object can build ships");
		if(obj.canBuildOrbitals)  print("Object can build orbitals");
		if(obj.canBuildAsteroids)  print("Object can build asteroids");
		if(obj.canTerraform)  print("Object can terraform");
		if(obj.canBuildSupports)  print("Object can build supports only");
		*/
		if(obj.hasConstruction && !obj.canBuildShips && !obj.canBuildOrbitals && !obj.canBuildAsteroids && !obj.canTerraform)
			obj.canExportLabor = false;
	}

	void disable(Object& obj, any@ data) const override {
		if(obj.hasConstruction && !obj.canBuildShips && !obj.canBuildOrbitals && !obj.canBuildAsteroids && !obj.canTerraform)
			obj.canExportLabor = true;
	}
#section all
};

class AddDuplicateSurfaceArea : BonusEffect {
	Document doc("On the planet, add an extra section of usable space on the surface.");
	Argument biome(AT_PlanetBiome, doc="Biome of the added space.");
	//Argument size(AT_Position2D, doc="Size of the added space.");
	Argument void_biome(AT_PlanetBiome, "Space", doc="Biome of the separating space.");
	Argument separate(AT_Boolean, "True", doc="Whether to separate the added space from the rest of the planet by using the void biome.");
	Argument developed(AT_Boolean, "True", doc="Whether the added tiles should be developed.");
	Argument vertical(AT_Boolean, "False", doc="Whether to add it below the existing surface, vertically.");

#section server
	void activate(Object@ obj, Empire@ emp) const override {
		if(obj is null || !obj.hasSurfaceComponent)
			return;
		//obj.addSurfaceArea(vec2i(size.fromPosition2D()), biome.integer, void_biome.integer, separate.boolean, developed.boolean, vertical.boolean);
		obj.addSurfaceArea(obj.get_originalGridSize(), biome.integer, void_biome.integer, separate.boolean, developed.boolean, vertical.boolean);
	}
#section all
};
/*
class AddIncomeToOtherPlanetsInSystem : GenericEffect, TriggerableGeneric {
	Document doc("Increase the income of all other planets in system by an amount.");
	Argument amount(AT_Integer, doc="Amount of income to add to other planets.");

#section server
	void enable(Object& obj, any@ data) const override {
		//Region@ reg = cast<Region>(obj);
		Region@ reg = obj.region;
		if(reg is null)  return;
		if(reg.planets.length > 0)  {
			for(uint i = 0; i < reg.planets.length-1; ++i) {
				Planet@ planet = reg.planets[i];
				if(planet.obj !is null && planet.obj != obj)  {
					//if(obj.hasSurfaceComponent)
					planet.obj.modIncome(+amount.integer);
				}
			}
		}
	}

	void disable(Object& obj, any@ data) const override {
		//Region@ reg = cast<Region>(obj);
		Region@ reg = obj.region;
		if(reg is null)  return;
		if(reg.planets.length > 0)  {
			for(uint i = 0; i < reg.planets.length-1; ++i) {
				Planet@ planet = reg.planets[i];
				if(planet.obj !is null && planet.obj != obj)  {
					//if(obj.hasSurfaceComponent)
					planet.obj.modIncome(-amount.integer);
				}
			}
		}
	}
#section all
};
*/

class AddPressureToOtherPlanetsInSystem : GenericEffect, TriggerableGeneric {
	Document doc("Add extra pressure to other planets in the system this object occupies.");
	Argument type(AT_TileResource, doc="Type of pressure to give.");
	Argument amount(AT_Integer, doc="Amount of pressure.");

#section server
	void enable(Object& obj, any@ data) const override {
		//Region@ reg = cast<Region>(obj);
		Region@ reg = obj.region;
		if(reg is null || !obj.isPlanet)  return;
		uint pCount = reg.get_planetCount();
		Planet@ origin = cast<Planet>(obj);
		Planet@ planet;
		//Empire @owner = obj.owner;
		if(pCount > 0)  {
			for(uint i = 0; i < pCount; ++i) {
				@planet = reg.get_planets(i);
				if(planet !is null && planet.owner is obj.owner && planet !is origin)  {
					//if(obj.hasSurfaceComponent)
					planet.modPressure(arguments[0].integer, +arguments[1].integer);
				}
			}
		}
	}

	void disable(Object& obj, any@ data) const override {
		//Region@ reg = cast<Region>(obj);
		Region@ reg = obj.region;
		if(reg is null || !obj.isPlanet)  return;
		uint pCount = reg.get_planetCount();
		Planet@ origin = cast<Planet>(obj);
		Planet@ planet;
		//Empire @owner = obj.owner;
		if(pCount > 0)  {
			for(uint i = 0; i < pCount; ++i) {
				@planet = reg.get_planets(i);
				if(planet !is null && planet.owner is obj.owner && planet !is origin)  {
					//if(obj.hasSurfaceComponent)
					planet.modPressure(arguments[0].integer, -arguments[1].integer);
				}
			}
		}
	}
#section all
};

/*
class SpawnShipInPlanetOrbit : EmpireTrigger {
	Document doc("Spawn a ship against a particular system.");
	Argument design(AT_Custom);
	Argument design_from(AT_Custom, "Player");
	Argument add_status(AT_Status, doc="Type of status effect to add to the ship.");
	Argument forCreeps(AT_Boolean, "False", doc="Is the ship for the Creeps and not the player.");
	Argument isFree(AT_Boolean, "False", doc="Is the ship free or not.");

#section server
	void activate(Object@ obj, Empire@ emp) const override {
		if(obj is null)  return;
		Empire@ designEmp = emp;
		if(design_from.str.length != 0) {
			if(design_from.str.equals_nocase("Creeps") || design_from.str.equals_nocase("Remnants")) {
				@designEmp = Creeps;
			}
			if(design_from.str.equals_nocase("Pirates")  {
				@designEmp = Pirates;
			}
		}
		Planet@ pl = cast<Planet>(obj);
		vec2d off = random2d(pl.radius + 0.1, pl.OrbitSize - 0.1);
		Region@ region = obj.region;
		auto@ dsg = designEmp.getDesign(design.str);
		if(dsg is null)  return;
		if(forCreeps)  {			
			Ship@ leader = createShip(pl.position + vec3d(off.x, 0.0, off.y), dsg, Creeps, isFree);
			leader.addStatus(status.integer, -1.0, Creeps, originObject=region);
		}
		else  {
			Ship@ leader = createShip(pl.position + vec3d(off.x, 0.0, off.y), dsg, emp, isFree);
			leader.addStatus(status.integer, -1.0, emp, originObject=region);
		}
	}
#section all
};
*/

class IDMercenaryCost : EmpireEffect, TriggerableGeneric {
	Document doc("Change the object's name.");
	//Argument name(AT_Custom, doc="Name to change to.");

#section server
	/*
	void activate(Object@ obj, Empire@ emp) const {
		if(obj !is null) {
			obj.name = getRandomFlagshipName();
			obj.named = true;
			//objectRenamed(ALL_PLAYERS, obj, name.str);
			Ship@ flagship = cast<Ship>(obj);
			flagship.modFleetEffectiveness(+0.15);
		}
	}
	*/
	void enable(Empire& emp, Object@ obj) {
		if(obj !is null) {
			Ship@ flagship = cast<Ship>(obj);
			int maintCost = getMaintenanceCost(flagship.blueprint.design)*2;
			emp.modTotalBudget(-maintCost, MoT_Misc);
			print("Maintenance charge = "+maintCost);
		}
		else  print("Object was null");
	}

	void disable(Empire& emp, Object@ obj) {
		if(obj !is null) {
			Ship@ flagship = cast<Ship>(obj);
			int maintCost = getMaintenanceCost(flagship.blueprint.design)*2;
			emp.modTotalBudget(maintCost, MoT_Misc);
			print("Maintenance refund = "+maintCost);
		}
		else  print("Object was null");
	}
#section all
};

class DOFGrantRandomName : GenericEffect {
	Document doc("Give the object a randomized name.");

#section server
	void activate(Object@ obj, Empire@ emp)  {
		if(obj is null)
			return;
		string name;
		if(obj.isShip) {
			name = getRandomFlagshipName();
		}
		else if(obj.isPlanet) {
			name = getRandomPlanetName();
		}
		else {
			return;
		}

		obj.name = name;
		obj.named = true;
		//objectRenamed(ALL_PLAYERS, obj, name);
	}
#section all
};

double DOFgetMassFor(Object& obj) {
#section server
	switch(obj.type) {
		case OT_Artifact:
			return getArtifactType(cast<Artifact>(obj).ArtifactType).mass;
		case OT_Asteroid:
			return config::ASTEROID_MASS;
		case OT_Ship:
			return cast<Ship>(obj).getBaseMass();
			//return cast<Ship>(obj).blueprint.design.total(HV_Mass);
		case OT_Orbital: {
			auto@ mod = getOrbitalModule(cast<Orbital>(obj).coreModule);
			if(mod !is null && mod.mass >= 0)
				return mod.mass;
		}
	}
#section all
	//return 20 * sqr(obj.radius);//
	switch(obj.type) {
		case OT_Artifact:
			return getArtifactType(cast<Artifact>(obj).ArtifactType).mass;
		case OT_Asteroid:
			return config::ASTEROID_MASS;
		case OT_Ship:
			//return cast<Ship>(obj).getBaseMass();
			return cast<Ship>(obj).blueprint.design.total(HV_Mass);
		case OT_Orbital: {
			auto@ mod = getOrbitalModule(cast<Orbital>(obj).coreModule);
			if(mod !is null && mod.mass >= 0)
				return mod.mass;
		}
	}
	//return 10000;
	return 20 * sqr(obj.radius);
}

class DOFTargetFilterAllowTractor : TargetFilter {
	Argument objTarget(TT_Object);
	Argument limit(AT_SysVar, doc="Percentage of hp to add.");

	string getFailReason(Empire@ emp, uint index, const Target@ targ) const override {
		return locale::ABL_TRACTOR_NO;
	}

	bool isValidTarget(Object@ tractor, Empire@ emp, uint index, const Target@ targ) const override {
		if(index != uint(objTarget.integer))
			return true;
		if(targ.obj is null)
			return false;
		if(targ.obj.isArtifact)
			if(limit.fromShipEfficiencySum(tractor) >= DOFgetMassFor(targ.obj))
				return true;
		if(targ.obj.isAsteroid)
			if(limit.fromShipEfficiencySum(tractor) >= DOFgetMassFor(targ.obj))
				return true;
		if(targ.obj.isShip)  {
			//print("Target Mass = "+DOFgetMassFor(targ.obj)+".  Limit = "+limit.fromShipEfficiencySum(tractor));
			if(limit.fromShipEfficiencySum(tractor) >= DOFgetMassFor(targ.obj))
				return targ.obj.owner !is null && targ.obj.owner.major;
		}
		if(targ.obj.isOrbital)
			if(limit.fromShipEfficiencySum(tractor) >= DOFgetMassFor(targ.obj))
				return true;
		return false;
	}
};
