import requirement_effects;

class RequirePlanetLevel : Requirement {
	Document doc("This can only work if the planet is of a particular level.");
	Argument level(AT_Integer, doc="Level to require.");
	Argument hide(AT_Boolean, "True", doc="Hide when unavailable.");
	Argument exact(AT_Boolean, "False", doc="Filter for exactly this level, instead of at least this level.");

	bool meets(Object& obj, bool ignoreState = false) const override {
		if(ignoreState && !hide.boolean)
			return true;
		if(exact.boolean)
			return obj.level == uint(level.integer);
		else
			return obj.level >= uint(level.integer);
	}

	string getFailError(Object& obj, bool ignoreState = false) const {
		return format(locale::CANNOT_BUILD_LEVEL, toString(level.integer));
	}
};

/*
class RequireNotEmpireAttribute : Requirement {
	Document doc("Check to see if an empire's boolean attribute has not been increased");
	Argument attribute(AT_EmpAttribute, doc="Which attribute to check.");

	bool meets(Object& obj, bool ignoreState = false) const {
		Empire@ owner = obj.owner;
		if(owner is null || !owner.valid)
			return false;
		if(!owner.getAttribute(attribute.integer) == 0)
			return false;
		return true;
	}
};
*/