// Research
// --------
// Spends research points to unlock and improve things in the research grid.
//

import empire_ai.weasel.WeaselAI;

import research;

//DOF
from traits import getTraitID;

class Research : AIComponent {
	TechnologyGrid grid;
	array<TechnologyNode@> immediateQueue;
	
	//DOF - Targeted research
	array<uint> ResearchTargets;
	array<bool> ResearchTargetsCompletion;
	uint CurrentResearchTarget = 0;
	bool bResearchTargetsInitialized = false;
	
	void AddResearchTargetByID(uint Target)  {
		ResearchTargets.insertLast(Target);
	}	
	
	void AddResearchTargetByName(string Target)  {
		updateGrid();
		print("Searching "+grid.nodes.length+" Techs for:  "+Target);
		for (uint i = 0; i < grid.nodes.length; ++i)  {
			//print("Tech found:  "+grid.nodes[i].type.name);
			//print("Tech found:  "+grid.nodes[i].type.ident);
			if (grid.nodes[i].type.name == Target)  {
				//print("Match found at ID:  "+i);
				ResearchTargets.insertLast(i);
			}
		}
	}	
	
	bool IsResearchTargetCompleted(int Target)  {
		if (grid.nodes[ResearchTargets[Target]].bought)  {
			ResearchTargetsCompletion[Target] = true;//}
		//if (ResearchTargetsCompletion[Target])  {
			return true;}
		return false;
	}
	
	bool GetAllResearchTargetsCompleted()  {
		for (uint i = 0; i < ResearchTargets.length; ++i)  {
			//if (IsResearchTargetCompleted(i))  {return false;}
			//print("Research target: "+i+" = "+grid.nodes[ResearchTargets[i]].type.name);			
			if (!grid.nodes[ResearchTargets[i]].bought)  {return false;}			
		}
		return true;
	}
	
	uint GetResearchTarget()  {
		for (uint i = 0; i < ResearchTargets.length; ++i)  {
			//if (ResearchTargetsCompletion[i] != true)  {			
			if (!grid.nodes[ResearchTargets[i]].bought)  {
				CurrentResearchTarget = i;
				//print("Current Research target: "+i+" = "+grid.nodes[ResearchTargets[i]].type.name);
				return i;
			}
		}
		return 999;
	}
	
	void InitResearchTargets()  {
		if(ai.empire.hasTrait(getTraitID("AncientsCannonical")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(39);	//FleetComputer
				//research.AddResearchTargetByName("AtlanteanControlChair");
				AddResearchTargetByID(245);
				//research.AddResearchTargetByName("ShieldHardenerAncients");
				AddResearchTargetByID(87);	//Antimatter
				//research.AddResearchTargetByName("ZeroPointModule");
				AddResearchTargetByID(97);	
				//research.AddResearchTargetByName("AtlanteanCityShipHull");
				AddResearchTargetByID(93);
				//research.AddResearchTargetByName("GravityEngine");
				AddResearchTargetByID(32);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(105);	//Flak Battery
				//research.AddResearchTargetByName("AncientDroneControl");
				AddResearchTargetByID(169);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(58);	//Drone Launcher
				//research.AddResearchTargetByName("AncientDronePhasic");
				AddResearchTargetByID(221);	//Drone Count
				//research.AddResearchTargetByName("AncientDroneCount");
				AddResearchTargetByID(64);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(62);	//Shield Harmonizer
				//research.AddResearchTargetByName("PlasmaThermite");
			}
			//Should not have non-Heralds scenario
		}
		else if(ai.empire.hasTrait(getTraitID("Asgard")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(73);	//Neutronium
				//research.AddResearchTargetByName("TriniumArmor");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(256);
				//research.AddResearchTargetByName("PhasedAntimatterCannon");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
				AddResearchTargetByID(32);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(44);
				//research.AddResearchTargetByName("DestroyerHull");
				AddResearchTargetByID(105);	//Flak Batter
				//research.AddResearchTargetByName("Supercapacitors");
				AddResearchTargetByID(169);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(58);	//Drone Launcher
				//research.AddResearchTargetByName("BeamOverload");
				AddResearchTargetByID(221);	//Drone Count
				//research.AddResearchTargetByName("PlasmaThermite");
				AddResearchTargetByID(64);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(127);
				//research.AddResearchTargetByName("StationMaintenance");
			}
			else  {
				AddResearchTargetByID(6);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(15);
				//research.AddResearchTargetByName("SysTriniumArmor");
				AddResearchTargetByID(73);
				//research.AddResearchTargetByName("SysShipComupter");
				AddResearchTargetByID(151);
				//research.AddResearchTargetByName("SysPhasedAntimatterCannon");
				AddResearchTargetByID(143);
				//research.AddResearchTargetByName("SysAntimatterGen");
				AddResearchTargetByID(132);	//Imp Shield Reg 2
				//research.AddResearchTargetByName("ImpShieldReg2");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("Goauld")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(87);	//Antimatter
				//research.AddResearchTargetByName("NaquadriaGenerator");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("Tauri")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(42);
				//research.AddResearchTargetByName("PlasmaBeam");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("Wraith")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);	//Ship Computer
				//research.AddResearchTargetByName("WraithQueenChamber");
				AddResearchTargetByID(135);	//Hydroponics
				//research.AddResearchTargetByName("WraithNodeBrain");
				AddResearchTargetByID(87);	//Antimatter
				//research.AddResearchTargetByName("WraithNodeBioelectric");
				AddResearchTargetByID(245);	//Shield Hardener
				//research.AddResearchTargetByName("DOFactionsArmorMasteryHeralds2");
				AddResearchTargetByID(62);	//Shield Harmonizer
				//research.AddResearchTargetByName("PlasmaThermite");
				AddResearchTargetByID(105);	//Flak Batter
				//research.AddResearchTargetByName("PlasmaCooldown");
			}
			else  {
				AddResearchTargetByID(6);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(73);
				//research.AddResearchTargetByName("WraithQueenChamber");
				AddResearchTargetByID(104);	//Megacity
				//research.AddResearchTargetByName("WraithNodeBrain");
				AddResearchTargetByID(143);
				//research.AddResearchTargetByName("WraithNodeBioelectric");
				AddResearchTargetByID(131);	//Shield Hardener
				//research.AddResearchTargetByName("DOFactionsArmorMasteryHeralds2");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("SWEmpire")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(19);	//Titan Hull
				//research.AddResearchTargetByName("SuperStarDestroyerHull");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
				AddResearchTargetByID(97);	//Colossus Hull	 - Not sure if this will work since it's an special lock
				//research.AddResearchTargetByName("ImperialConstruction");
			}
			else  {
				AddResearchTargetByID(6);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(73);
				//research.AddResearchTargetByName("SysShipComupter");
				AddResearchTargetByID(18);	//Titan Hull
				//research.AddResearchTargetByName("SysSuperStarDestroyerHull");
				AddResearchTargetByID(143);
				//research.AddResearchTargetByName("SysAntimatterGen");
				AddResearchTargetByID(148);	//Not sure if this will work since it's an special lock
				//research.AddResearchTargetByName("DevImperialConstruction");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("SWRepublic")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(44);
				//research.AddResearchTargetByName("DestroyerHull");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(19);
				//research.AddResearchTargetByName("TitanHull");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
				AddResearchTargetByID(97);	
				//research.AddResearchTargetByName("ColossusHull");
			}
			else  {
				AddResearchTargetByID(6);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(73);
				//research.AddResearchTargetByName("SysShipComupter");
				AddResearchTargetByID(143);
				//research.AddResearchTargetByName("SysAntimatterGen");
				AddResearchTargetByID(18);
				//research.AddResearchTargetByName("SysTitanHull");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("SWCIS")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(19);
				//research.AddResearchTargetByName("TitanHull");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
			}
			else  {
				AddResearchTargetByID(6);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(73);
				//research.AddResearchTargetByName("SysShipComupter");
				AddResearchTargetByID(143);
				//research.AddResearchTargetByName("SysAntimatterGen");
				AddResearchTargetByID(18);
				//research.AddResearchTargetByName("SysTitanHull");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("BSGColonial")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(39);
				//research.AddResearchTargetByName("FleetComputer");
				AddResearchTargetByID(95);
				//research.AddResearchTargetByName("Prosperity");
				AddResearchTargetByID(62);	//Shield Harmonizer
				//research.AddResearchTargetByName("FlagHealth2");
				AddResearchTargetByID(161);
				//research.AddResearchTargetByName("Damage2");
				AddResearchTargetByID(166);
				//research.AddResearchTargetByName("FlagHealth2");
				AddResearchTargetByID(205);	//Warheads
				//research.AddResearchTargetByName("WarheadsRefinement");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("BSGCylon")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);	//Computer
				//research.AddResearchTargetByName("CylonHybrid");
				AddResearchTargetByID(39);	//FleetComputer
				//research.AddResearchTargetByName("FleetComputer");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("STFederation")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(39);	//FleetComputer
				//research.AddResearchTargetByName("TorpedoQuantum");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
				AddResearchTargetByID(35);	//Booster Engine
				//research.AddResearchTargetByName("DeflectorShieldsRegenerative");
				AddResearchTargetByID(62);	//Shield Harmonizer
				//research.AddResearchTargetByName("DeflectorShieldsMLSS");
				AddResearchTargetByID(103);	//Deflector Array
				//research.AddResearchTargetByName("DeflectorShieldsInstances");
				AddResearchTargetByID(64);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(32);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(169);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(107);	//Hyper Laser
				//research.AddResearchTargetByName("TorpedoTransphasic");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("STBorg")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(39);	//FleetComputer
				//research.AddResearchTargetByName("TorpedoGraviton");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
				AddResearchTargetByID(20);	//Shield Gen
				//research.AddResearchTargetByName("AdaptationMax");
				AddResearchTargetByID(245);	//Shield Hardener
				//research.AddResearchTargetByName("AdaptationMax");
				AddResearchTargetByID(62);	//Shield Harmonizer
				//research.AddResearchTargetByName("AdaptationMax");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("STKlingon")))  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(39);	//FleetComputer
				//research.AddResearchTargetByName("KlingonBattleCommander");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
				AddResearchTargetByID(35);	//Booster Engine
				//research.AddResearchTargetByName("DeflectorShieldsRegenerative");
				AddResearchTargetByID(32);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(64);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
				AddResearchTargetByID(169);	//Shield Regen 2
				//research.AddResearchTargetByName("ShieldReg2");
			}
		}
		else if(ai.empire.hasTrait(getTraitID("Verdant")))  {
			if(hasDLC("Heralds")) {
				//Vaaish Design targets
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(17);
				//research.AddResearchTargetByName("ShieldGen");
				AddResearchTargetByID(142);
				//research.AddResearchTargetByName("Thrust2");
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(87);
				//research.AddResearchTargetByName("AntimatterGen");
				AddResearchTargetByID(106);
				//research.AddResearchTargetByName("FlakBattery");
				AddResearchTargetByID(79);
				//research.AddResearchTargetByName("Nanomesh");
				AddResearchTargetByID(128);
				//research.AddResearchTargetByName("QuantumBattery");
				AddResearchTargetByID(111);
				//research.AddResearchTargetByName("ParticleLance");
				AddResearchTargetByID(58);
				//research.AddResearchTargetByName("DroneLauncher");
				AddResearchTargetByID(19);
				//research.AddResearchTargetByName("TitanHull");
				AddResearchTargetByID(31);
				//research.AddResearchTargetByName("TargetSensor");
				AddResearchTargetByID(56);
				//research.AddResearchTargetByName("AugmentReload");
				AddResearchTargetByID(126);
				//research.AddResearchTargetByName("AugmentDamage");				
				//Original Targets
				AddResearchTargetByID(95);
				//research.AddResearchTargetByName("Prosperity");
				AddResearchTargetByID(161);
				//research.AddResearchTargetByName("Damage2");
				AddResearchTargetByID(166);
				//research.AddResearchTargetByName("FlagHealth2");
				AddResearchTargetByID(139);
				//research.AddResearchTargetByName("Wealth");
				AddResearchTargetByID(156);
				//research.AddResearchTargetByName("FlagHealth2");
			}
			else  {
				//Vaaish Design Targets
				AddResearchTargetByID(6);
				//research.AddResearchTargetByName("ModBulkhead");
				AddResearchTargetByID(32);
				//research.AddResearchTargetByName("SysShieldGen");
				AddResearchTargetByID(73);
				//research.AddResearchTargetByName("SysShipComupter");
				AddResearchTargetByID(143);
				//research.AddResearchTargetByName("SysAntimatterGen");
				AddResearchTargetByID(18);
				//research.AddResearchTargetByName("SysTitanHull");
				AddResearchTargetByID(141);
				//research.AddResearchTargetByName("ModQuantumBattery");
				AddResearchTargetByID(77);
				//research.AddResearchTargetByName("ModTargetSensor");
				AddResearchTargetByID(80);
				//research.AddResearchTargetByName("ModAugmentReload");
				AddResearchTargetByID(118);
				//research.AddResearchTargetByName("ModAugmentDamage");
				//Original Targets
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("DevBudgetSmall");
				AddResearchTargetByID(21);
				//research.AddResearchTargetByName("ImpAllHealth2");
				AddResearchTargetByID(25);
				//research.AddResearchTargetByName("KeyBuildCost");
				AddResearchTargetByID(89);
				//research.AddResearchTargetByName("ImpDamage2");
			}
		}
		else  {
			if(hasDLC("Heralds")) {
				AddResearchTargetByID(37);
				//research.AddResearchTargetByName("ShipComputer");
				AddResearchTargetByID(95);
				//research.AddResearchTargetByName("Prosperity");
				AddResearchTargetByID(17);
				//research.AddResearchTargetByName("ShieldGen");
				AddResearchTargetByID(161);
				//research.AddResearchTargetByName("Damage2");
				AddResearchTargetByID(166);
				//research.AddResearchTargetByName("FlagHealth2");
				AddResearchTargetByID(139);
				//research.AddResearchTargetByName("Wealth");
			}
			else  {
				AddResearchTargetByID(2);
				//research.AddResearchTargetByName("DevBudgetSmall");
				AddResearchTargetByID(72);
				//research.AddResearchTargetByName("ShipComupter");
				AddResearchTargetByID(32);
				//research.AddResearchTargetByName("SysShieldGen");
				AddResearchTargetByID(21);
				//research.AddResearchTargetByName("ImpAllHealth2");
				AddResearchTargetByID(25);
				//research.AddResearchTargetByName("KeyBuildCost");
				AddResearchTargetByID(89);
				//research.AddResearchTargetByName("ImpDamage2");
			}
		}
	}
	
	bool GetTargetPath(int current, array<TechnologyNode@>& chosen, array<TechnologyNode@>& tmp, array<bool>& visited)  {
		bool success = false;
		
		auto@ node = grid.nodes[current];

		//if(grid.nodes[current].bought || current == 0)  {
		if(node.bought || current == 0)  {
			success = true;
			if(chosen.length == 0)  {
				chosen = tmp;
				//print("Found successful path length:  "+chosen.length);
			}
			else if(tmp.length < chosen.length)  {
				chosen = tmp;
				//print("Found shorter path length:  "+chosen.length);
			}
			return success;
		}
		
		if(!node.hasRequirements(ai.empire))  return success;
		if(tmp.length > 20)  return success;
		
		//if(tmp.find(grid.nodes[current]) != -1)  return success;
		//else  tmp.insertLast(grid.nodes[current]);
		
		//if(visited[current])
		//if(visited[current] && tmp.length < 20)
		//	return success;
		//visited[current] = true;
		
		//auto@ node = grid.nodes[current];
		vec2i startPos = node.position;
		
		//int step = tmp.length;
		array<TechnologyNode@> part;
		part = tmp;
		//array<bool> vtemp(grid.nodes.length, false);
		//vtemp = visited;
		
		for(uint d = 0; d < 6; ++d) {
			//print("Attempting d = "+d+" from "+current);
			vec2i otherPos = startPos;
			if(grid.doAdvance(otherPos, HexGridAdjacency(d))) {
				int otherIndex = grid.getIndex(otherPos);
				if(otherIndex != -1 && part.find(grid.nodes[otherIndex]) == -1) {
				//if(otherIndex != -1) {
					//if(otherIndex == 0)  print("Checking 0 on d = "+d+" from "+current+".  Path length = "+part.length);
					part = tmp;
					//vtemp = visited;
					//tmp.length = step;
					part.insertLast(grid.nodes[otherIndex]);
					//Recursive Step
					if(GetTargetPath(otherIndex, chosen, part, visited))  {
					//if(GetTargetPath(otherIndex, chosen, part, vtemp))  {
						if(!success)  success = true;
						//print("Success from:  "+otherIndex+".  Part length:  "+part.length);
						//print("success on d = "+d+" from "+current+" to "+otherIndex);
						//if(otherIndex == 0)  print("Success to 0 on d = "+d+" from "+current+".  Path length = "+part.length);
					}
				}
			}
		}
		return success;
	}
	
	bool QueueTargetedResearch(int TargetIndex)  {
		//Get target node and exit as failure if already completed
		int Target = ResearchTargets[TargetIndex];
		if(grid.nodes[Target].bought)  {
			ResearchTargetsCompletion[TargetIndex] = true;
			return false;
		}
		
		//Find a path to research
		array<bool> visited(grid.nodes.length, false);	
		array<TechnologyNode@> tmp;
		array<TechnologyNode@> chosen;
		
		auto@ TargetNode = grid.nodes[Target];
		
		//If we do not have the reqs to even do the target, fail
		if(!TargetNode.hasRequirements(ai.empire))  return false;

		tmp.insertLast(TargetNode);
		
		bool FoundPath = GetTargetPath(Target, chosen, tmp, visited);
		
		if(FoundPath && chosen.length != 0)  {
			//Add to immediateQueue
			for(uint i = chosen.length; i > 0; --i)  {
				immediateQueue.insertLast(chosen[i-1]);
			}
			return true;
		}
		
		//Unable to find path, exit as failure
		return false;
	}
	//End of DOF addition

	void save(SaveFile& file) {
		uint cnt = immediateQueue.length;
		file << cnt;
		for(uint i = 0; i < cnt; ++i)
			file << immediateQueue[i].id;
	}

	void load(SaveFile& file) {
		updateGrid();

		uint cnt = 0;
		file >> cnt;
		for(uint i = 0; i < cnt; ++i) {
			int id = 0;
			file >> id;

			for(uint i = 0, cnt = grid.nodes.length; i < cnt; ++i) {
				if(grid.nodes[i].id == id) {
					immediateQueue.insertLast(grid.nodes[i]);
					break;
				}
			}
		}

	}

	void updateGrid() {
		//Receive the full grid from the empire to path on
		grid.nodes.length = 0;

		DataList@ recvData = ai.empire.getTechnologyNodes();
		TechnologyNode@ node = TechnologyNode();
		while(receive(recvData, node)) {
			grid.nodes.insertLast(node);
			@node = TechnologyNode();
		}

		grid.regenBounds();
	}

	double getEndPointWeight(const TechnologyType& tech) {
		//TODO: Might want to make this configurable by data file
		return 1.0;
	}

	bool isEndPoint(const TechnologyType& tech) {
		return tech.cls >= Tech_BigUpgrade;
	}

	double findResearch(int atIndex, array<TechnologyNode@>& path, array<bool>& visited, bool initial = false) {
		if(visited[atIndex])
			return 0.0;
		visited[atIndex] = true;

		auto@ node = grid.nodes[atIndex];
		if(!initial) {
			if(node.bought)
				return 0.0;
			if(!node.hasRequirements(ai.empire))
				return 0.0;

			path.insertLast(node);

			if(isEndPoint(node.type))
				return getEndPointWeight(node.type);
		}

		vec2i startPos = node.position;
		double totalWeight = 0.0;

		array<TechnologyNode@> tmp;
		array<TechnologyNode@> chosen;
		tmp.reserve(20);
		chosen.reserve(20);

		for(uint d = 0; d < 6; ++d) {
			vec2i otherPos = startPos;
			if(grid.doAdvance(otherPos, HexGridAdjacency(d))) {
				int otherIndex = grid.getIndex(otherPos);
				if(otherIndex != -1) {
					tmp.length = 0;
					double w = findResearch(otherIndex, tmp, visited);
					if(w != 0.0) {
						totalWeight += w;
						if(randomd() < w / totalWeight) {
							chosen = tmp;
						}
					}
				}
			}
		}

		for(uint i = 0, cnt = chosen.length; i < cnt; ++i)
			path.insertLast(chosen[i]);
		return max(totalWeight, 0.01);
	}

	void queueNewResearch() {
		if(log)
			ai.print("Attempted to find new research to queue");

		//Update our grid representation
		updateGrid();
		
		

		//Find a good path to do
		array<bool> visited(grid.nodes.length, false);

		double totalWeight = 0.0;

		auto@ path = array<TechnologyNode@>();
		auto@ tmp = array<TechnologyNode@>();
		path.reserve(20);
		tmp.reserve(20);

		
		//DOF - Targetted Research
		int ResearchTarget = GetResearchTarget();
		if (!GetAllResearchTargetsCompleted() && ResearchTarget != 999)  {
			//double weight = findResearch(ResearchTarget, tmp, visited, initial=true);
			//if(weight != 0.0) {
				//totalWeight += weight;
				//if(randomd() < weight / totalWeight) {
					//auto@ swp = path;
					//@path = tmp;
					//@tmp = swp;
				//}
			//}
			//Randomization:  Reduce forced target research by 5% per target depth
			if(randomd() < max(0.25,(1-CurrentResearchTarget*0.05)))  {
				if(QueueTargetedResearch(ResearchTarget))  {return;}
			}
		}
		//else  {
		
		//Fall back to standard research method
		for(int i = 0, cnt = grid.nodes.length; i < cnt; ++i) {
			if(grid.nodes[i].bought) {
				tmp.length = 0;
				double weight = findResearch(i, tmp, visited, initial=true);
				if(weight != 0.0) {
					totalWeight += weight;
					if(randomd() < weight / totalWeight) {
						auto@ swp = path;
						@path = tmp;
						@tmp = swp;
					}
				}
			}
		}
		//  End of DOF modification
		
		if(path.length != 0) {
			for(uint i = 0, cnt = path.length; i < cnt; ++i) {
				if(log)
					ai.print("Queue research: "+path[i].type.name+" at "+path[i].position);
				immediateQueue.insertLast(path[i]);
			}
		}
	}

	double immTimer = randomd(10.0, 60.0);
	void focusTick(double time) override {
		//DOF
		
		if (!bResearchTargetsInitialized)  {
			InitResearchTargets();
			bResearchTargetsInitialized = true;
		}
		
		//Queue some new research if we have to
		if(immediateQueue.length == 0) {
			immTimer -= time;
			if(immTimer <= 0.0) {
				immTimer = 60.0;
				queueNewResearch();
			}
		}
		else {
			immTimer = 0.0;
		}

		//Deal with current queued research
		if(immediateQueue.length != 0) {
			auto@ node = immediateQueue[0];
			if(!receive(ai.empire.getTechnologyNode(node.id), node)) {
				immediateQueue.removeAt(0);
			}
			else if(!node.available || node.bought) {
				immediateQueue.removeAt(0);
			}
			else {
				double cost = node.getPointCost(ai.empire);
				if(cost == 0) {
					//Try it once and then give up
					ai.empire.research(node.id, secondary=true);
					immediateQueue.removeAt(0);

					if(log)
						ai.print("Attempt secondary research: "+node.type.name+" at "+node.position);
				}
				else if(cost <= ai.empire.ResearchPoints) {
					//If we have enough to buy it, buy it
					ai.empire.research(node.id);
					immediateQueue.removeAt(0);

					if(log)
						ai.print("Purchase research: "+node.type.name+" at "+node.position);
				}
			}
		}
	}
};

AIComponent@ createResearch() {
	return Research();
}
